diff -urN ../VisualBoyAdvance-1.7.2/src/arm-new.h ./src/arm-new.h
--- ../VisualBoyAdvance-1.7.2/src/arm-new.h	2004-05-13 22:57:11 +0900
+++ ./src/arm-new.h	2006-08-25 22:30:08 +0900
@@ -2950,18 +3611,22 @@
       reg[destLo].I = (u32)uTemp;
       reg[destHi].I = (u32)(uTemp >> 32);
       if ((usource & 0xFFFFFF00) == 0)
-        clockTicks += 2;
+        clockTicks += 0;
       else if ((usource & 0xFFFF0000) == 0)
-        clockTicks += 3;
+        clockTicks += 1;
       else if ((usource & 0xFF000000) == 0)
-        clockTicks += 4;
+        clockTicks += 2;
       else
-        clockTicks += 5;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
+      clockTicks += codeTicksAccess32(armNextPC) + 1;
     }
     break;
   case 0x099:
     {
       // UMULLS RdLo, RdHi, Rn, Rs
+      clockTicks = 2;
       u32 umult = reg[(opcode & 0x0F)].I;
       u32 usource = reg[(opcode >> 8) & 0x0F].I;
       int destLo = (opcode >> 12) & 0x0F;         
@@ -2972,13 +3637,16 @@
       Z_FLAG = (uTemp) ? false : true;
       N_FLAG = (reg[destHi].I & 0x80000000) ? true : false;
       if ((usource & 0xFFFFFF00) == 0)
-        clockTicks += 2;
+        clockTicks += 0;
       else if ((usource & 0xFFFF0000) == 0)
-        clockTicks += 3;
+        clockTicks += 1;
       else if ((usource & 0xFF000000) == 0)
-        clockTicks += 4;
+        clockTicks += 2;
       else
-        clockTicks += 5;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
+      clockTicks += codeTicksAccess32(armNextPC) + 1;
     }
     break;
     ARITHMETIC_DATA_OPCODE(OP_ADC,  OP_ADC, 0x0a0);
@@ -2986,6 +3654,7 @@
   case 0x0a9:
     {
       // UMLAL RdLo, RdHi, Rn, Rs
+      clockTicks = 3;
       u32 umult = reg[(opcode & 0x0F)].I;
       u32 usource = reg[(opcode >> 8) & 0x0F].I;
       int destLo = (opcode >> 12) & 0x0F;         
@@ -2997,18 +3666,22 @@
       reg[destLo].I = (u32)uTemp;
       reg[destHi].I = (u32)(uTemp >> 32);
       if ((usource & 0xFFFFFF00) == 0)
-        clockTicks += 3;
+        clockTicks += 0;
       else if ((usource & 0xFFFF0000) == 0)
-        clockTicks += 4;
+        clockTicks += 1;
       else if ((usource & 0xFF000000) == 0)
-        clockTicks += 5;
+        clockTicks += 2;
       else
-        clockTicks += 6;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
+      clockTicks += codeTicksAccess32(armNextPC) + 1;
     }
     break;
   case 0x0b9:
     {
       // UMLALS RdLo, RdHi, Rn, Rs
+      clockTicks = 3;
       u32 umult = reg[(opcode & 0x0F)].I;
       u32 usource = reg[(opcode >> 8) & 0x0F].I;
       int destLo = (opcode >> 12) & 0x0F;         
@@ -3022,13 +3695,16 @@
       Z_FLAG = (uTemp) ? false : true;
       N_FLAG = (reg[destHi].I & 0x80000000) ? true : false;
       if ((usource & 0xFFFFFF00) == 0)
-        clockTicks += 3;
+        clockTicks += 0;
       else if ((usource & 0xFFFF0000) == 0)
-        clockTicks += 4;
+        clockTicks += 1;
       else if ((usource & 0xFF000000) == 0)
-        clockTicks += 5;
+        clockTicks += 2;
       else
-        clockTicks += 6;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
+      clockTicks += codeTicksAccess32(armNextPC) + 1;
     }
     break;
     ARITHMETIC_DATA_OPCODE(OP_SBC,  OP_SBC, 0x0c0);
@@ -3036,6 +3712,7 @@
   case 0x0c9:
     {
       // SMULL RdLo, RdHi, Rm, Rs
+      clockTicks = 2;
       int destLo = (opcode >> 12) & 0x0F;         
       int destHi = (opcode >> 16) & 0x0F;
       u32 rs = reg[(opcode >> 8) & 0x0F].I;
@@ -3047,18 +3724,22 @@
       if(((s32)rs) < 0)
         rs = ~rs;
       if((rs & 0xFFFFFF00) == 0)
-        clockTicks += 2;
+        clockTicks += 0;
       else if((rs & 0xFFFF0000) == 0)
-        clockTicks += 3;
+        clockTicks += 1;
       else if((rs & 0xFF000000) == 0)
-        clockTicks += 4;
+        clockTicks += 2;
       else
-        clockTicks += 5;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
+      clockTicks += codeTicksAccess32(armNextPC) + 1;
     }
     break;
   case 0x0d9:
     {
       // SMULLS RdLo, RdHi, Rm, Rs
+      clockTicks = 2;
       int destLo = (opcode >> 12) & 0x0F;         
       int destHi = (opcode >> 16) & 0x0F;
       u32 rs = reg[(opcode >> 8) & 0x0F].I;
@@ -3072,13 +3753,16 @@
       if(((s32)rs) < 0)
         rs = ~rs;
       if((rs & 0xFFFFFF00) == 0)
-        clockTicks += 2;
+        clockTicks += 0;
       else if((rs & 0xFFFF0000) == 0)
-        clockTicks += 3;
+        clockTicks += 1;
       else if((rs & 0xFF000000) == 0)
-        clockTicks += 4;
+        clockTicks += 2;
       else
-        clockTicks += 5;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
+      clockTicks += codeTicksAccess32(armNextPC) + 1;
     }
     break;
     ARITHMETIC_DATA_OPCODE(OP_RSC,  OP_RSC, 0x0e0);
@@ -3086,6 +3770,7 @@
   case 0x0e9:
     {
       // SMLAL RdLo, RdHi, Rm, Rs
+      clockTicks = codeTicksAccess32(armNextPC) + 4;
       int destLo = (opcode >> 12) & 0x0F;         
       int destHi = (opcode >> 16) & 0x0F;
       u32 rs = reg[(opcode >> 8) & 0x0F].I;
@@ -3100,18 +3785,21 @@
       if(((s32)rs) < 0)
         rs = ~rs;
       if((rs & 0xFFFFFF00) == 0)
-        clockTicks += 3;
+        clockTicks += 0;
       else if((rs & 0xFFFF0000) == 0)
-        clockTicks += 4;
+        clockTicks += 1;
       else if((rs & 0xFF000000) == 0)
-        clockTicks += 5;
+        clockTicks += 2;
       else
-        clockTicks += 6;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
     }
     break;
   case 0x0f9:
     {
       // SMLALS RdLo, RdHi, Rm, Rs
+      clockTicks = codeTicksAccess32(armNextPC) + 4;
       int destLo = (opcode >> 12) & 0x0F;         
       int destHi = (opcode >> 16) & 0x0F;
       u32 rs = reg[(opcode >> 8) & 0x0F].I;
@@ -3128,13 +3816,15 @@
       if(((s32)rs) < 0)
         rs = ~rs;
       if((rs & 0xFFFFFF00) == 0)
-        clockTicks += 3;
+        clockTicks += 0;
       else if((rs & 0xFFFF0000) == 0)
-        clockTicks += 4;
+        clockTicks += 1;
       else if((rs & 0xFF000000) == 0)
-        clockTicks += 5;
+        clockTicks += 2;
       else
-        clockTicks += 6;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
     }
     break;
     LOGICAL_DATA_OPCODE(OP_TST, OP_TST, 0x110);
@@ -3151,6 +3841,8 @@
       u32 temp = CPUReadMemory(address);
       CPUWriteMemory(address, reg[opcode&15].I);
       reg[(opcode >> 12) & 15].I = temp;
+      clockTicks = 4 + dataTicksAccess32(address) + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
     LOGICAL_DATA_OPCODE(OP_TEQ, OP_TEQ, 0x130);
@@ -3174,23 +3866,33 @@
       CPUSwitchMode(newValue & 0x1f, false);
       reg[16].I = newValue;
       CPUUpdateFlags();
+      if(!armState) { // this should not be allowed, but it seems to work
+        THUMB_PREFETCH;
+        reg[15].I = armNextPC + 2;
+      }
     }
     break;
   case 0x121:
     {
       // BX Rm
       // TODO: check if right instruction...
-      clockTicks += 3;
       int base = opcode & 0x0F;
+      busPrefetchCount=0;
       armState = reg[base].I & 1 ? false : true;
       if(armState) {
         reg[15].I = reg[base].I & 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks = codeTicksAccessSeq32(armNextPC) +
+            codeTicksAccessSeq32(armNextPC) + codeTicksAccess32(armNextPC) + 3;
       } else {
         reg[15].I = reg[base].I & 0xFFFFFFFE;
         armNextPC = reg[15].I;
         reg[15].I += 2;
+        THUMB_PREFETCH;
+        clockTicks = codeTicksAccessSeq16(armNextPC) +
+            codeTicksAccessSeq16(armNextPC) + codeTicksAccess16(armNextPC) + 3;
       }
     }
     break;
@@ -3207,6 +3909,8 @@
       u32 temp = CPUReadByte(address);
       CPUWriteByte(address, reg[opcode&15].B.B0);
       reg[(opcode>>12)&15].I = temp;
+      clockTicks = 4 + dataTicksAccess32(address) + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
     ARITHMETIC_DATA_OPCODE(OP_CMN, OP_CMN, 0x170);
@@ -3284,6 +3988,10 @@
       CPUSwitchMode(newValue & 0x1f, false);
       reg[16].I = newValue;
       CPUUpdateFlags();
+      if(!armState) { // this should not be allowed, but it seems to work
+        THUMB_PREFETCH;
+        reg[15].I = armNextPC + 2;
+      }
     }
     break;
   case 0x360:
@@ -3326,13 +4034,16 @@
   CASE_16(0x420)
     {
       // STR Rd, [Rn], -#
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I;
       CPUWriteMemory(address, reg[dest].I);
       reg[base].I = address - offset;
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x480)
@@ -3340,64 +4051,81 @@
   CASE_16(0x4a0)
     {
       // STR Rd, [Rn], #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I;
       CPUWriteMemory(address, reg[dest].I);
       reg[base].I = address + offset;
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x500)
     {
       // STR Rd, [Rn, -#]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x520)
     {
       // STR Rd, [Rn, -#]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[base].I = address;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x580)
     {
       // STR Rd, [Rn, #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x5a0)
     {
       // STR Rd, [Rn, #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[base].I = address;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x410)
     {
       // LDR Rd, [Rn], -#
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -3405,18 +4133,23 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I -= offset;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x430)
     {
       // LDRT Rd, [Rn], -#
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -3424,12 +4157,23 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I -= offset;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x490)
     {
       // LDR Rd, [Rn], #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -3437,18 +4181,23 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I += offset;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x4b0)
     {
       // LDRT Rd, [Rn], #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -3456,29 +4205,45 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I += offset;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x510)
     {
       // LDR Rd, [Rn, -#]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[dest].I = CPUReadMemory(address);
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x530)
     {
       // LDR Rd, [Rn, -#]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -3486,35 +4251,45 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
-    }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
+  }
     break;
   CASE_16(0x590)
     {
       // LDR Rd, [Rn, #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[dest].I = CPUReadMemory(address);
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x5b0)
     {
       // LDR Rd, [Rn, #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -3522,13 +4297,16 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x440)
@@ -3536,73 +4314,91 @@
   CASE_16(0x460)
     {
       // STRB Rd, [Rn], -#
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I;
       CPUWriteByte(address, reg[dest].B.B0);
       reg[base].I = address - offset;
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x4c0)
     // T versions shouldn't be different on GBA
   CASE_16(0x4e0)
-    // STRB Rd, [Rn], #
     {
+      // STRB Rd, [Rn], #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I;
       CPUWriteByte(address, reg[dest].B.B0);
       reg[base].I = address + offset;
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x540)
     {
       // STRB Rd, [Rn, -#]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x560)
     {
       // STRB Rd, [Rn, -#]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[base].I = address;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x5c0)
     {
       // STRB Rd, [Rn, #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x5e0)
     {
       // STRB Rd, [Rn, #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[base].I = address;
       CPUWriteByte(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x450)
@@ -3610,6 +4406,8 @@
   CASE_16(0x470)
     {
       // LDRB Rd, [Rn], -#
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -3617,13 +4415,24 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I -= offset;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x4d0)
   CASE_16(0x4f0) // T versions should not be different
     {
       // LDRB Rd, [Rn], #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -3631,23 +4440,45 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I += offset;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x550)
     {
       // LDRB Rd, [Rn, -#]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[dest].I = CPUReadByte(address);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x570)
     {
       // LDRB Rd, [Rn, -#]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -3655,23 +4486,45 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x5d0)
     {
       // LDRB Rd, [Rn, #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[dest].I = CPUReadByte(address);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x5f0)
     {
       // LDRB Rd, [Rn, #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = opcode & 0xFFF;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -3679,7 +4532,16 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x600:
@@ -3689,13 +4551,16 @@
   case 0x628:
     {
       // STR Rd, [Rn], -Rm, LSL #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I;
       CPUWriteMemory(address, reg[dest].I);
       reg[base].I = address - offset;
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x602:
@@ -3705,6 +4570,8 @@
   case 0x62a:
     {
       // STR Rd, [Rn], -Rm, LSR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -3712,7 +4579,8 @@
       u32 address = reg[base].I;
       CPUWriteMemory(address, reg[dest].I);
       reg[base].I = address - offset;
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x604:
@@ -3722,6 +4590,8 @@
   case 0x62c:
     {
       // STR Rd, [Rn], -Rm, ASR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -3735,7 +4605,8 @@
       u32 address = reg[base].I;
       CPUWriteMemory(address, reg[dest].I);
       reg[base].I = address - offset;
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x606:
@@ -3745,6 +4616,8 @@
   case 0x62e:
     {
       // STR Rd, [Rn], -Rm, ROR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -3757,7 +4630,8 @@
       u32 address = reg[base].I;
       CPUWriteMemory(address, reg[dest].I);
       reg[base].I = address - value;
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x680:
@@ -3767,13 +4641,16 @@
   case 0x6a8:
     {
       // STR Rd, [Rn], Rm, LSL #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I;
       CPUWriteMemory(address, reg[dest].I);
       reg[base].I = address + offset;
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x682:
@@ -3783,6 +4660,8 @@
   case 0x6aa:
     {
       // STR Rd, [Rn], Rm, LSR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -3790,7 +4669,8 @@
       u32 address = reg[base].I;
       CPUWriteMemory(address, reg[dest].I);
       reg[base].I = address + offset;
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x684:
@@ -3800,6 +4680,8 @@
   case 0x6ac:
     {
       // STR Rd, [Rn], Rm, ASR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -3813,7 +4695,8 @@
       u32 address = reg[base].I;
       CPUWriteMemory(address, reg[dest].I);
       reg[base].I = address + offset;
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x686:
@@ -3823,6 +4706,8 @@
   case 0x6ae:
     {
       // STR Rd, [Rn], Rm, ROR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
